import keras
import keras.backend as K
import numpy as np
import scipy.linalg
import scipy.stats
import tensorflow as tf
import tensorflow.summary as tfsum


# --- Fast Food Naive --- #


def G_variable(shape, trainable=False):
    """
    Return a Gaussian Random matrix converted into Tensorflow Variable.

    :param shape: The shape of the matrix (number of fastfood stacks (v), dimension of the input space (d))
    :type shape: int or tuple of int (tuple size = 2)
    :return: K.variable object containing the matrix, The norm2 of each line (np.array of float)
    """
    assert type(shape) == int or (type(shape) == tuple and len(shape) == 2)
    G = np.random.normal(size=shape).astype(np.float32)
    G_norms = np.linalg.norm(G, ord=2, axis=1)
    if trainable:
        return K.variable(G, name="G"), G_norms
    else:
        return K.constant(G, name="G"), G_norms


def B_variable(shape, trainable=False):
    """
    Return a random matrix of -1 and 1 picked uniformly and converted into Tensorflow Variable.

    :param shape: The shape of the matrix (number of fastfood stacks (v), dimension of the input space (d))
    :type shape: int or tuple of int (tuple size = 2)
    :return: K.variable object containing the matrix
    """
    assert type(shape) == int or (type(shape) == tuple and len(shape) == 2)
    B = np.random.choice([-1, 1], size=shape, replace=True).astype(np.float32)
    if trainable:
        return K.variable(B, name="B")
    else:
        return K.constant(B, name="B")


def P_variable(d, nbr_stack):
    """
    Return a permutation matrix converted into Tensorflow Variable.

    :param d: The width of the matrix (dimension of the input space)
    :type d: int
    :param nbr_stack: The height of the matrix (nbr_stack x d is the dimension of the output space)
    :type nbr_stack: int
    :return: K.variable object containing the matrix
    """
    idx = np.hstack([(i * d) + np.random.permutation(d) for i in range(nbr_stack)])
    P = np.random.permutation(np.eye(N=nbr_stack * d))[idx].astype(np.float32)
    return K.constant(P, name="P")


def H_variable(d):
    """
    Return an Hadamard matrix converted into Tensorflow Variable.

    d must be a power of two.

    :param d: The size of the Hadamard matrix (dimension of the input space).
    :type d: int
    :return: K.variable object containing the diagonal and not trainable
    """
    H = build_hadamard(d).astype(np.float32)
    return K.constant(H, name="H")


def S_variable(shape, G_norms, trainable=False):
    """
    Return a scaling matrix of random values picked from a chi distribution.

    The values are re-scaled using the norm of the associated Gaussian random matrix G. The associated Gaussian
    vectors are the ones generated by the `G_variable` function.

    :param shape: The shape of the matrix (number of fastfood stacks (v), dimension of the input space (d))
    :type shape: int or tuple of int (tuple size = 2)
    :param G_norms: The norms of the associated Gaussian random matrices G.
    :type G_norms: np.array of floats
    :return: K.variable object containing the matrix.
    """
    S = np.multiply((1 / G_norms.reshape((-1, 1))), scipy.stats.chi.rvs(shape[1], size=shape).astype(np.float32))
    if trainable:
        return K.variable(S, name="S")
    else:
        return K.constant(S, name="S")


def fastfood_layer(conv_out, sigma, nbr_stack=1, trainable=False):
    """
    Return a fastfood transform op compatible with tensorflow graph.

    Implementation largely inspired from https://gist.github.com/dougalsutherland/1a3c70e57dd1f64010ab .

    See:
    "Fastfood | Approximating Kernel Expansions in Loglinear Time" by
    Quoc Le, Tamas Sarl and Alex Smola.

    :param conv_out: the input of the op
    :param sigma: bandwith of the gaussian distribution
    :param nbr_stack: number of fast food stacks
    :param trainable: the diagonal matrices are trainable or not
    :return: the output of the fastfood transform
    """
    raise NotImplementedError("fastfood_layer function is not yet correctly implemented in keras")
    with K.name_scope("fastfood" + "_sigma-" + str(sigma)):
        init_dim = np.prod([s.value for s in conv_out.shape if s.value is not None])
        final_dim = int(dimensionality_constraints(init_dim))
        padding = final_dim - init_dim
        conv_out2 = K.reshape(conv_out, [-1, init_dim])
        paddings = K.constant([[0, 0], [0, padding]])
        conv_out2 = K.pad(conv_out2, paddings, "CONSTANT")

        G, G_norm = G_variable((nbr_stack, final_dim), trainable=trainable)
        tfsum.histogram("weights_G", G)
        B = B_variable((nbr_stack, final_dim), trainable=trainable)
        tfsum.histogram("weights_B", B)
        H = H_variable(final_dim)
        tfsum.histogram("weights_H", H)
        P = P_variable(final_dim, nbr_stack)
        tfsum.histogram("weights_P", P)
        S = S_variable((nbr_stack, final_dim), G_norm, trainable=trainable)
        tfsum.histogram("weights_S", S)

        conv_out2 = K.reshape(conv_out2, (1, -1, 1, final_dim))
        h_ff1 = conv_out2 * B
        h_ff1 = K.reshape(h_ff1, (-1, final_dim))
        h_ff2 = K.dot(h_ff1, H)
        h_ff2 = K.reshape(h_ff2, (-1, final_dim * nbr_stack))
        h_ff3 = K.dot(h_ff2, P)
        h_ff4 = K.reshape(h_ff3, (-1, final_dim * nbr_stack)) * K.reshape(G, (-1, final_dim * nbr_stack))
        h_ff4 = K.reshape(h_ff4, (-1, final_dim))
        h_ff5 = K.dot(h_ff4, H)

        h_ff6 = (1. / (sigma * np.sqrt(final_dim))) * K.reshape(h_ff5, (-1, final_dim * nbr_stack)) * K.reshape(S, (-1, final_dim * nbr_stack))
        h_ff7_1 = K.cos(h_ff6)
        h_ff7_2 = K.sin(h_ff6)
        h_ff7 = K.sqrt(float(1 / final_dim)) * K.concatenate([h_ff7_1, h_ff7_2], axis=1)
    return h_ff7


# --- Hadamard utils --- #


def dimensionality_constraints(d):
    """
    Enforce d to be a power of 2

    :param d: the original dimension
    :return: the final dimension
    """
    if not is_power_of_two(d):
        # find d that fulfills 2^l
        d = np.power(2, np.floor(np.log2(d)) + 1)
    return d


def is_power_of_two(input_integer):
    """ Test if an integer is a power of two. """
    if input_integer == 1:
        return False
    return input_integer != 0 and ((input_integer & (input_integer - 1)) == 0)


def build_hadamard(n_neurons):
    return scipy.linalg.hadamard(n_neurons)


class FastFoodLayer(keras.layers.Layer):
    def __init__(self, sigma, nbr_stack, trainable=True, **kwargs):
        super().__init__(**kwargs)
        self.__sigma = sigma
        self.__nbr_stack = nbr_stack
        self.__trainable = trainable

        self.__init_dim = None
        self.__final_dim = None

    def build(self, input_shape):
        with K.name_scope("fastfood" + "_sigma-" + str(self.__sigma)):
            self.__init_dim = np.prod([s for s in input_shape if s is not None])
            self.__final_dim = int(dimensionality_constraints(self.__init_dim))
            self.num_outputs = None

            G, G_norm = G_variable((self.__nbr_stack, self.__final_dim))
            self.__G = self.add_weight(
                name="G",
                shape=(self.__nbr_stack, self.__final_dim),
                initializer=lambda *args, **kwargs: G,
                trainable=self.__trainable
            )

            B = B_variable((self.__nbr_stack, self.__final_dim))
            self.__B = self.add_weight(
                name="B",
                shape=(self.__nbr_stack, self.__final_dim),
                initializer=lambda *args, **kwargs: B,
                trainable=self.__trainable
            )

            H = H_variable(self.__final_dim)
            self.__H = self.add_weight(
                name="H",
                shape=(self.__final_dim, self.__final_dim),
                initializer=lambda *args, **kwargs: H,
                trainable=False
            )

            P = P_variable(self.__final_dim, self.__nbr_stack)
            self.__P = self.add_weight(
                name="P",
                shape=(self.__final_dim * self.__nbr_stack, self.__final_dim * self.__nbr_stack),
                initializer=lambda *args, **kwargs: P,
                trainable=False
            )

            S = S_variable((self.__nbr_stack, self.__final_dim), G_norm)
            self.__S = self.add_weight(
                name="S",
                shape=(self.__final_dim * self.__nbr_stack, self.__final_dim * self.__nbr_stack),
                initializer=lambda *args, **kwargs: S,
                trainable=self.__trainable
            )

        self.num_outputs = self.__final_dim * self.__nbr_stack

    def call(self, input, **kwargs):
        padding = self.__final_dim - self.__init_dim
        conv_out2 = K.reshape(input, [-1, self.__init_dim])
        paddings = K.constant([[0, 0], [0, padding]], dtype=np.int32)
        conv_out2 = tf.pad(conv_out2, paddings, "CONSTANT")
        conv_out2 = K.reshape(conv_out2, (1, -1, 1, self.__final_dim))
        h_ff1 = conv_out2 * self.__B
        h_ff1 = K.reshape(h_ff1, (-1, self.__final_dim))
        h_ff2 = K.dot(h_ff1, self.__H)
        h_ff2 = K.reshape(h_ff2, (-1, self.__final_dim * self.__nbr_stack))
        h_ff3 = K.dot(h_ff2, self.__P)
        h_ff4 = K.reshape(h_ff3, (-1, self.__final_dim * self.__nbr_stack)) * K.reshape(self.__G, (-1, self.__final_dim * self.__nbr_stack))
        h_ff4 = K.reshape(h_ff4, (-1, self.__final_dim))
        h_ff5 = K.dot(h_ff4, self.__H)

        h_ff6 = (1 / (self.__sigma * np.sqrt(self.__final_dim))) * K.reshape(h_ff5, (-1, self.__final_dim * self.__nbr_stack)) * K.reshape(self.__S, (-1, self.__final_dim * self.__nbr_stack))
        h_ff7_1 = K.cos(h_ff6)
        h_ff7_2 = K.sin(h_ff6)
        h_ff7 = np.sqrt(float(1 / self.__final_dim)) * K.concatenate([h_ff7_1, h_ff7_2], axis=1)
        return h_ff7

    def compute_output_shape(self, input_shape):
        return (input_shape[0], 2 * input_shape[1] * self.__nbr_stack)
